import { GraphQLSchema, DocumentNode } from 'graphql';
import { InMemoryLRUCache } from 'apollo-server-caching';
import { ApolloServerPlugin } from 'apollo-server-plugin-base';
import { GraphQLServerOptions } from './graphqlOptions';
import { Config } from './types';
import { PlaygroundRenderPageOptions } from './playground';
import { GraphQLRequest } from './requestPipeline';
import { SchemaHash } from 'apollo-server-types';
declare type SchemaDerivedData = {
    schema: GraphQLSchema;
    schemaHash: SchemaHash;
    documentStore?: InMemoryLRUCache<DocumentNode>;
};
export declare class ApolloServerBase {
    private logger;
    graphqlPath: string;
    requestOptions: Partial<GraphQLServerOptions<any>>;
    private context?;
    private apolloConfig;
    protected plugins: ApolloServerPlugin[];
    protected playgroundOptions?: PlaygroundRenderPageOptions;
    private parseOptions;
    private config;
    private state;
    private toDispose;
    private toDisposeLast;
    private experimental_approximateDocumentStoreMiB;
    constructor(config: Config);
    start(): Promise<void>;
    protected _start(): Promise<void>;
    protected ensureStarted(): Promise<SchemaDerivedData>;
    protected assertStarted(methodName: string): void;
    private logStartupError;
    private startGatewayAndLoadSchema;
    private constructSchema;
    private maybeAddMocksToConstructedSchema;
    private generateSchemaDerivedData;
    stop(): Promise<void>;
    protected serverlessFramework(): boolean;
    private ensurePluginInstantiation;
    private initializeDocumentStore;
    protected graphQLServerOptions(integrationContextArgument?: Record<string, any>): Promise<GraphQLServerOptions>;
    executeOperation(request: GraphQLRequest, integrationContextArgument?: Record<string, any>): Promise<import("apollo-server-types").GraphQLResponse>;
}
export {};
//# sourceMappingURL=ApolloServer.d.ts.map