import type { CacheHint, GraphQLRequestContext } from 'apollo-server-types';
import type { InternalApolloServerPlugin } from '../../internalPlugin';
export interface ApolloServerPluginCacheControlOptions {
    defaultMaxAge?: number;
    calculateHttpHeaders?: boolean;
    __testing__cacheHints?: Map<string, CacheHint>;
}
declare module 'graphql/type/definition' {
    interface GraphQLResolveInfo {
        cacheControl: {
            setCacheHint: (hint: CacheHint) => void;
            cacheHint: CacheHint;
        };
    }
}
export declare class PolicyUpdater {
    private requestContext;
    private overallCachePolicyIsUncacheable;
    constructor(requestContext: Pick<GraphQLRequestContext, 'overallCachePolicy'>);
    addHint(hint: CacheHint): void;
}
export declare function ApolloServerPluginCacheControl(options?: ApolloServerPluginCacheControlOptions): InternalApolloServerPlugin;
export declare function ApolloServerPluginCacheControlDisabled(): InternalApolloServerPlugin;
//# sourceMappingURL=index.d.ts.map